unit Unit2;
{$R tank.res}
interface
uses unit3,Graphics,SysUtils,types;

type
TTank=class
        procedure Move(const x0,y0:integer);
        procedure FirstPosition(const x0,y0:integer;d0:byte;st:string);
        function GetX:integer;   //  
        function GetY:integer;
        procedure SetD(const d0:byte); // 
        private
         x,y:integer;     //  
         d:byte;          // :, 
         pix:array[1..8]of TBitMap;    // 
           //  1-,2-, 3-, 4-
         fon_buf: TBitMap;   //  
         

      end;

implementation
uses unit1;
var
i:integer;

PROCEDURE TTank.FirstPosition(const x0,y0:integer;d0:byte;st:string);
BEGIN
x:=x0;      // 
y:=y0;
d:=d0;
for i:=1 to 8 do           // 
 begin
  pix[i]:=TBitMap.Create;
  pix[i].LoadFromResourceName(HInstance,st+inttostr(i));
  pix[i].TransparentColor:=clBlack;
  pix[i].Transparent:=false;
 end;

// 
fon_buf:=TBitMap.Create;
fon_buf.Height:=wh;
fon_buf.Width:=wh;
fon_buf.Palette:=fon.Palette;
fon_buf.Canvas.CopyMode:=cmSrcCopy;
fon_buf.Canvas.CopyRect(bounds(1,1,wh,wh),fon.Canvas,bounds(x,y,x+wh,y+wh));
// 
Form1.Image1.Canvas.Draw(x,y,pix[d]);
END;

PROCEDURE TTank.Move(const x0,y0:integer);
var
tmp1,tmp2:TRect;
BEGIN
//  
Form1.Image1.Canvas.Draw(x,y,fon_buf);

x:=x0;
y:=y0;
// 
fon_buf.Canvas.CopyRect(bounds(1,1,wh,wh),fon.Canvas,bounds(x,y,x+wh,y+wh));
// 
if d>4 then d:=d-4 else d:=d+4;
Form1.Image1.Canvas.Draw(x,y,pix[d]);
END;

FUNCTION TTank.GetX:integer;
BEGIN
GetX:=x;
END;

FUNCTION TTank.GetY:integer;
BEGIN
GetY:=y;
END;

PROCEDURE TTank.SetD(const d0:byte);
BEGIN
case d0 of
1:if (d<>1)and(d<>1+4) then d:=1;
2:if (d<>2)and(d<>2+4) then d:=2;
3:if (d<>3)and(d<>3+4) then d:=3;
4:if (d<>4)and(d<>4+4) then d:=4;
end;
END;

end.
